/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		battery.cpͯ ̧
 *
 *		1-Wire(R)(PʐM)̍\ݒƓdrް̓p`ƏԍXV֐܂
 *		܂B\n
 *		܂Adrް̒`RIDNTC̎Qƕ\p̐錾܂݂܂B
 *
 * \par pLq:
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xEҰ			: avr@atmel.com \n
 *		{			: \n
 *
 * $Name$
 * $Revision: 2335 $
 * $RCSfile$
 * $URL: http://svn.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/battery.h $
 * $Date: 2007-09-07 10:11:19 +0200 (Fri, 07 Sep 2007) $\n
 ******************************************************************************/

#ifndef BATTERY_H
#define BATTERY_H

#ifdef __GNUC__
  #include <avr/eeprom.h>
#endif

//******************************************************************************
// RIDȂ[d(BatteryStatusRefresh()p)
//******************************************************************************
//#define ALLOW_NO_RID						//!< sv̏ꍇɊdrްgp܂B

#define DEF_BAT_CAPACITY		0			//!< mAhł̊dre
#define DEF_BAT_CURRENT_MAX		0			//!< mAł̊ő[dd
#define DEF_BAT_TIME_MAX		0			//!< ł̊ő[d
#define DEF_BAT_CURRENT_MIN		0			//!< [d~邽߂mAł̊ŏd

//******************************************************************************
// RIDNTC̒`ƍ\̐錾
//******************************************************************************
#define RID_TABLE_SIZE			4			//!< RID\̓o^
#define NTC_TABLE_SIZE			20			//!< NTC\̓o^

//! \brief o^IDQƕ\ڗp\
struct RID_Lookup_struct {
	unsigned int Low;						//!< ŒዖeA/Dϊl
	unsigned int High;						//!< ōeA/Dϊl
	unsigned int Resistance;				//!< łRIDRl
	unsigned int Capacity;					//!< mAhł̑Ήdre
	unsigned int Icharge;					//!< mAł̑Ή[dd
	unsigned int tCutOff;					//!< ł̑Ή~
	unsigned int ICutOff;					//!< mAł̑Ή~d
};
typedef struct RID_Lookup_struct RID_Lookup_t;	//!< ֐̂

/*! \brief NTCQƕ\ڗp\
 *
 * \note ~ADCŐ񂳂Ȃ΂Ȃ܂B
 */

struct NTC_Lookup_struct {
	unsigned int TADC;						//!< NTCl
	unsigned char ADCsteps;					//!< ̉xł0.5A/DϊiK
};
typedef struct NTC_Lookup_struct NTC_Lookup_t;	//!< ֐̂

//******************************************************************************
// S̕ϐ
//******************************************************************************

#ifdef __GNUC__
  extern EEMEM Battery_t BattControl[];
#elif __ICCAVR__
  extern __eeprom Battery_t BattControl[];
#else
  #error Current COMPILER not supported
#endif

extern Batteries_t BattData;

#ifdef __GNUC__
  extern EEMEM unsigned char BattEEPROM[][32];
#elif __ICCAVR__
  extern __eeprom unsigned char BattEEPROM[][32];
#else
  #error Current COMPILER not supported
#endif

extern unsigned char BattActive;

//******************************************************************************
// ֐^錾
//******************************************************************************
unsigned char BatteryCheck(void);
unsigned char BatteryStatusRefresh(void);
unsigned char BatteryDataRefresh(void);
unsigned char RIDLookUp(void);
void NTCLookUp(void);

#endif // BATTERY_H
