/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		ADC.cpͯ ̧
 *
 *		A/Dϊ̍\ݒƍŏdp̒`܂݂܂B
 *
 * \par pLq:
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par 
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xEҰ			: avr@atmel.com \n
 *		{			: \n
 *
 * $Name$
 * $Revision: 2335 $
 * $RCSfile$
 * $URL: http://svn.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/ADC.h $
 * $Date: 2007-09-07 10:11:19 +0200 (Fri, 07 Sep 2007) $\n
 ******************************************************************************/

#ifndef ADC_H
#define ADC_H

//******************************************************************************
// A/Dϊ\ݒ
//******************************************************************************
// 8MHz(25~128)=2500̎/b (ch)
#define ADC_PRESCALER	0x07
/*!< \brief A/Dϊۯ̑Ou
 *
 * A/Dϊ8MHz( ۯ)128OuősA̍̎͊T25v
 * ܂B
 * ̎摬x=8MHz(128~25/̎)=2.5k̎/b
 */

// IBAT
#define R_SHUNT_OHMS	1		//
#define R1_OHMS			13		// ADC1,ADC0:R1~(R1+R2)
#define R2_OHMS			10
#define VREF_I			256L	// IBAT(~100)pADCd
#define VREF_V			2560L	// IBAT(~1000)pADCd
#define ADC_GAIN		10		// ADC~10
#define ADC_ACCURACY	512L	// ł8ޯĐx

// ~1000 mVł̌=(vref~100)(ADC~10)
#define I_SCALE_1		((R1_OHMS + R2_OHMS)*(VREF_I))
#define I_SCALE_2		(R_SHUNT_OHMS * R1_OHMS * ADC_ACCURACY)

#define VBAT_SCALE_1	(long)((R1_OHMS + R2_OHMS)*(VREF_V))
#define VBAT_SCALE_2	(long)(R1_OHMS * ADC_ACCURACY * 2)

//******************************************************************************
// ŏd
//******************************************************************************
//! (TP101=VIN+ɉ)mVł̍ŏd
#define VIN_MIN			4400


//******************************************************************************
// S̕ϐ
//******************************************************************************
//cgs extern __eeprom unsigned char VBAT_RANGE;
extern unsigned char VBAT_RANGE;
extern volatile ADC_Status_t ADCS;

//******************************************************************************
// ֐^錾
//******************************************************************************
#ifdef __GNUC__
ISR(ADC_vect);
#else
#pragma vector = ADC_vect
__interrupt void ADC_ISR(void);
#endif

unsigned int ScaleU(unsigned int data);
unsigned int ScaleI(unsigned int data);
void ADC_Wait(void);
void ADC_Init(void);

#endif // ADC_H
