/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		ADCgp̂߂̊֐
 *
 *		ADCA荞ݏA̎̏邽߂̏ʊ֐܂݂܂B\n
 *		ADC͘Aϊ(Rs)ɐݒ肳AOdgp܂B\n
 *		SĂ̍̎悪Œ25ۯ邽߁AADC͊荞ݏٰ(ISR)ɂ
 *		Ē~čĊJ܂B
 *
 * \par pLq:
 *      AVRxxx: ATmega32U4łUSBoR ݓdr[d\n
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xEҰ			: avr@atmel.com
 *		{			: \n
 *
 * $Name$
 * $Revision:$
 * $RCSfile$
 * $URL:$
 * $Date:$\n
 ******************************************************************************/

#include "config.h"
#include "structs.h"
#include "main.h"
#include "lib_mcu/adc/adc.h"
#include "lib_mcu/adc/adc_drv.h"

#ifdef __GNUC__
  #include "lib_mcu/adc/adc.h"
  #include "lib_mcu/adc/adc_drv.h"
#elif __ICCAVR__
  #include "adc.h"
  #include "adc_drv.h"
#else
  #error Current COMPILER not supported
#endif

//******************************************************************************
// ϐ
//******************************************************************************
// A/Dϊԍ\
//! \brief ̎悵ްA/Dϊ̏Ԃێ܂B
volatile ADC_Status_t ADCS;

/*! \brief ődrdw
 *
 * ̕ϐEEPROMɊi[Adrd̎悳Oɂꂪǂʏkڂ
 * w܂Bkڗʂ͍ődrdɈˑAA/Dϊ̖Oa邽߂ɕKv
 * ł(d2.5Vł)B
 *
 * \note ScaleU()ScaleI()ĂԎA/DϊISRɂĎgp܂B
 *
 * \note 10V̍ődrdӖ1łB
 *
 * \note ݒ\
 * <pre>
 * VBAT_RANGE | ődrd | ެߐݒ
 *			0 |			  5V |		  1/2
 *			1 |			 10V |		  1/4
 *			2 |			 20V |		  1/8
 *			3 |			 30V |		 1/12
 *			4 |			 40V |		 1/16
 * </pre>
 */
// (̎̎ړxɉeyڂ)ődrd
//CGS __eeprom unsigned char VBAT_RANGE = 1;
unsigned char VBAT_RANGE = 1;

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief A/Dϊp荞ݏٰ(ISR)
 *
 * ISR͍̎悵lA/ϊԍ\̂Ɋi[AA/Dϊ푽d𑖍
 * ɉ鎟قɍXV܂B\n
 * 1x菇ƁAADCS.Flagݒ肳AADCS.Haltݒ肳ĂȂ΁A
 * ̎菇蒼܂BȂ΁AA/Dϊ͋֎~܂B\n
 * dŏȉȂAADCS.MainsFALSEɐݒ肳܂B
 * VREF = AVCC (5V)
 * \note 菇\
 * <pre>
 *  | MUX5 | MUX4:0 |     |   |  | 荀| 
 * -----+------+--------+-----------+----------+-------+-------------+-------
 *  01  |   0  |  01001 | ADC0/PF0  | / | ~10 | Vshunt- | Ȃ
 *      |      |        | ADC1/PF1  | / | ~10 | Vshunt+ | Ȃ
 *  02  |   0  |  00000 | ADC0/PF0  |   n/a   |  ~1 | Vbatt   | Ȃ
 *  03  |   1  |  00011 | ADC11/PB4 |   n/a   |  ~1 |  NTC    | Ȃ
 *  04  |   1  |  00100 | ADC12/PB5 |   n/a   |  ~1 |  RID    | Ȃ
 * </pre>
 *
 * \todo IIN(菇7)͌Ďgp܂B
 *
 * \todo t͌Đݒ肳܂BIBAT̕t͕qȑŁÂ
 * 2͍D܂܂BA傫ȓd(Ⴆ΁AdrƋɋN鉽)
 * (`ꂽPWM̓Ɉˑ)[dɍD܂Ȃ(Ⴆ΁A
 * ConstantCurrent()PWMo͂̑ێ)NȂƂĉ߂
 * ł傤BPWMُ킪}A۸тُԂ֍sAČ
 * ǍďɋA܂B
 */

#ifdef __GNUC__
 ISR(ADC_vect)
#else
#pragma vector = ADC_vect
__interrupt void ADC_ISR(void)
#endif
{
	static unsigned char avgIndex = 0;
	unsigned char i, Next;
	signed int  temp = 0;
	unsigned long temp_buffer;

	ADCSRA &= ~(1<<ADEN);		// Oɕϊ~A͑SϊŒ25A/Dϊۯɂ܂B(ōĊJ܂B)
	switch (ADCS.MUX)			// ǂق炩ɈˑĕϊAĎ菇ɉ鎟قɐ؂ւ܂B
	{
		case 0x01:				// MUX = 0x09 => ADC0/ADC1 (PF0/PF1) = Vshunt
			// ɂȂA-512`0`511A0x200`0x3FF,0x000,0x001`0x1FF
			if (ADC > 511)
			{
				// l(dr[d)
				temp_buffer = (I_SCALE_1 * (1024 -ADC)) / I_SCALE_2;
				ADCS.IBAT = -(signed int)temp_buffer;
			}
			else if (ADC > 0){
				// l(drd)
				temp_buffer = (I_SCALE_1 * ADC) / I_SCALE_2;
				ADCS.IBAT = (signed int)temp_buffer;
			}
			else
			{
				ADCS.IBAT = 0;
			}
			// drd𕽋ωzɑ}(łÂ㏑)Ǎ
			// ɍČvZĕςi[܂B͎菇̍Ō̕ϊŁÂ
			// A/Dϊ}Ď菇ĊJ܂B
			ADCS.discIBAT[(avgIndex++ & 0x03)] = ADCS.IBAT;
			for (i = 0; i < 4 ; i++)
			{
				temp += ADCS.discIBAT[i];
			}
			ADCS.avgIBAT = (temp / 4);
			Next=0x02;
			// ̑pɑd0x00ݒ(case=0x02)
			Clear_adc_mux();
			ADMUX = (1<<REFS1)|(1<<REFS0);
			ADCSRB = 0x00;
		break;

		case 0x02:				// MUX = 0x00 => ADC0 (PF0) = VBAT
			temp_buffer = (VBAT_SCALE_1 * ADC )/VBAT_SCALE_2;
			ADCS.rawVBAT = (unsigned int)temp_buffer;
		  	ADCS.VBAT = ADCS.rawVBAT;
			Next=0x03;
			// ̑pɑd0x23ݒ(case=0x03)
			Clear_adc_mux();
			ADMUX = (1<<REFS1)|(1<<REFS0)|(1<<MUX1)|(1<<MUX0);
			ADCSRB = (1<<MUX5);
		break;

		case 0x03:				// MUX = 0x23 => ADC11 (PB4) = NTC
			ADCS.rawNTC = ADC;
			Next=0x04;
			// ̑pɑd0x24ݒ(case=0x04)
			Clear_adc_mux();
			ADMUX = (1<<REFS1)|(1<<REFS0)|(1<<MUX2);
			ADCSRB = (1<<MUX5);
		break;

		case 0x04:				// MUX = 0x24 => ADC12 (PB5) = RID
			ADCS.rawRID = ADC;
			ADCS.Flag = TRUE;
			Next=0x01;
			// ̑pɑd0x09ݒ(case=0x01)
			Clear_adc_mux();
			ADMUX = (1<<REFS1)|(1<<REFS0)|(1<<MUX3)|(1<<MUX0);
		break;

		default:		// (NׂłȂ)d
			Next=0x01;	// 菇̐擪Jnɐݒ
			// ̑pɑd0x09ݒ(case=0x01)
			Clear_adc_mux();
			ADMUX = (1<<REFS1)|(1<<REFS0)|(1<<MUX3)|(1<<MUX0);
		break;
	}
	ADCS.MUX = Next;				// ٕۑ
	if (!((ADCS.Halt) && (ADCS.Flag))) {	// ~łȂϊ菇ŁA
	  ADCSRA |= (1<<ADEN)|(1<<ADSC);		// A/DϊĊJ(n)
	}
}

/*! \brief A/Dϊ2̊SȎ񂪋N̂ҋ@
 *
 * ̊֐͎񊮗׸ނAĂꂪĂѐݒ肳̂҂܂B
 * ケ͊֐𔲂OɈxJԂ܂B
 */
void ADC_Wait(void)
{
	Enable_adc();							// ADC
	ADCS.Flag = FALSE;						// A/Dϊ񊮗׸މ
	Start_conv();							// A/DϊJn
	do {									// A/Dϊҋ@
	} while (ADCS.Flag == FALSE);
	Enable_adc();							// ADC
	ADCS.Flag = FALSE;						// A/Dϊ񊮗׸މ
	Start_conv();							// 2ڂA/DϊJn
	do {									// A/Dϊҋ@
	} while (ADCS.Flag == FALSE);
	
	Disable_adc();							// (CDCCPUԂp邽߂)ADC~
}

/*! \brief A/DϊƓ݂
 *
 * ̊֐A/DϊOd(PA3)gpPA/2/4/5/6/7̎悷A
 * ϊ`Ԃɏ܂B\n
 * ͕ψ(̾)p̍Zް肵ĕۑ܂B
 *
 * \todo ADC3_G20_OSp̕ψʑǉĂB͂ǂxgp܂B
 *
 */
void ADC_Init(void)
{
	unsigned char i;

#ifdef __GNUC__
	Disable_interrupt();	// S̊荞݋֎~
#else
	__disable_interrupt();	// S̊荞݋֎~
#endif
	ADCS.Halt = FALSE;		// A/Dϊ~׸މ(A/Dϊps)
	DDRF &= ((1<<DDF1)|(1<<DDF0));			// ADC(PF0,PF1)͐ݒ
	PORTF &= ((1<<PORTF1)|(1<<PORTF0));		// ADC(PF0,PF1)ٱ߂Ȃݒ
	DDRB &= ((1<<DDB5)|(1<<DDB4));			// ADC(PB5,PB4)͐ݒ
	PORTB &= ((1<<PORTB5)|(1<<PORTB4));		// ADC(PB5,PB4)ٱ߂Ȃݒ
	DIDR0 |= ((1<<ADC1D)|(1<<ADC0D));		// ADC(PF0,PF1)޼ٓ͋֎~
	DIDR2 |= ((1<<ADC12D)|(1<<ADC11D));		// ADC(PB5,PB4)޼ٓ͋֎~

	ADCS.Flag = FALSE;						// A/Dϊ񊮗׸ޏ
	ADCS.MUX = 0x01;						// ϊَw
	// dƂē2.56VIAd0x09ɐݒ
	Clear_adc_mux();			
	ADMUX = (1<<REFS1)|(1<<REFS0)|(1<<MUX3)|(1<<MUX0);
	ADCS.avgIBAT = 0;						// ϓdl
	for (i = 0; i < 4; i++) {				// ϓdz񏉊
		ADCS.discIBAT[i] = 0;
	}
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADIE)|ADC_PRESCALER;	// A/DϊJn(荞ݗL)

#ifdef __GNUC__
	Enable_interrupt();						// S̊荞݋
#else
	__enable_interrupt();					// S̊荞݋
#endif

	ADC_Wait();								// ߂OްIB
}
